
#include <bits/stdc++.h>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    vector<vector<int>> graph(n + 1);

    for(int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;

        graph[u].push_back(v);
        graph[v].push_back(u);
    }

    vector<int> weight(n + 1, 0);
    vector<vector<bool>> beats(n + 1);
    vector<bool> can_gather(n + 1);
    vector<bool> beats_subtree(n + 1);

    for(int i = 1; i <= n; i++) {
        beats[i] = vector<int>(graph[i].size(), 0);
    }
    
    vector<unordered_map<int, int>> neighbor_index(n + 1);

    for(int i = 1; i <= n; i++) {
        for(int j = 0; j < (int)graph[i].size(); j++) {
            neighbor_index[i][graph[i][j]] = j;
        }
    }

    vector<pair<int, int> > weights;
    vector<int> dp_pref;
    vector<int> dp_suff;
    function<int(int, int)> dfs = [&](int nod, int tata) {
        int weight = 1;
        weights.assign(graph[nod].size(), make_pair(0, 0));
        for(int i = 0; i < (int)graph[nod].size(); i++) {
            if(graph[nod][i] == tata) {
                continue;
            }
            weights[i] = make_pair(dfs(it, nod), i);
            weight += weights[i];
        }

        for(int i = 0;i < (int)graph[nod].size(); i++) {
            weights[i] = make_pair(n - weight, i);
        }

        dp_pref.assign(weights.size(), -1);
        dp_suff.assign(weights.size(), -1);
        sort(weights.begin(), weights.end());
        
        int last_weight = 1;


        for(int i = 0; i < (int)weights.size(); i++) {
            if(last_weight >= weights[i].first) {
                last_weight += weights[i].first;
                dp_pref[i] = last_weight;
            } else {
                break;
            }
        }

        int last_dp = 0;
        for(int i = ((int)weights.size()) - 1; i >= 0; i--) {
            dp_suff[i] = max(weights[i].first, last_dp - weights[i].first);
        }
        
        for(int i = 0; i < (int)weights.size(); i++) {
            int last_dp = 1;
            if(i != 0) {
                last_dp = dp_pref[i - 1];
            }
            if(last_dp == -1) {
                continue;
            }
            if(i == ((int)weights.size()) - 1 || dp_suff[i + 1].first <= last_dp) {
                if(weight[i].first >= n - 1 - weights[i].first) { 
                    beats[nod][weights[i].second] = 1; 
            
                }
            }
        }

        can_gather[nod] = (dp_pref.back() != -1);
        beats_subtree[nod] = true;

        for(int i = 0; i < (int)graph[nod].size(); i++) {
            if(graph[nod] != tata) {
                beats_subtree[nod] &= beats_subtree[graph[nod][i]];
                beats_subtree[nod] &= beats[graph[nod][i]][neighbor_index[graph[nod][i]][nod]];
            }
        }
    };

    dfs(1, 0);
    
    function<void(int, int, bool)> dfs2 = [&](int nod, int tata, bool beats_tata) {
        if(!beats_tata) return;
        if(can_gather[nod]) {
            bool ok = true;
            for(int i = 0; i < (int)graph[nod].size(); i++) {
                if(!beats_subtree[graph[nod][i]] || !beats[graph[nod][i]][neighbor_index[graph[nod][i]][nod]]) {
                    ok = false;
                    break;
                }
            }
            if(ok) {
                cout << "YES";
                exit(0);
            }
        }

        for(int i = 0; i < (int)graph[nod].size(); i++) {
            if(graph[nod][i] == tata) {
                continue;
            }
            dfs2(graph[nod][i], nod, beats_tata && beats
        }
    };




    return 0;
}
